# Do more with WordPress, faster.

This is the way Web Artisans write software for WordPress: with elegance, simplicity, and readability.

*How?* By allowing you to build WordPress plugins with [Laravel](https://laravel.com). 

These plugins work just like normal WordPress plugins, except that they're 
each also Laravel [Service Containers](https://laravel.com/docs/5.3/container).

This means that in addition to behaving like WordPress plugins, they also behave 
much like Laravel apps do, and they inherit much of their structure from Laravel's design,
which is object-oriented, fluent, and effective.

Using this framework brings to your plugin projects the power of both
the Laravel framework and its community—we think you're going to love
what you discover there.

We want to be able to build *complex, custom applications* on top of WordPress, and 
we think this is the best way forward.

## Features

* Use Laravel to build WordPress plugins
* Better organization for plugin files and folders
* Fluent syntax for defining REST API routes and rewrite rules
* Simple subclassing to define custom post types, comment types, and taxonomies
* Make better use of third-party libraries via [Composer](https://getcomposer.org/)
* Unit testing with PHPUnit and WP-CLI
* Do more with WordPress, faster

See a complete working example plugin in the [auth-plugin-wordpress repo](https://github.com/withfatpanda/auth-plugin-wordpress)

## Getting Started

The easiest way to Illuminate your WordPress plugins is to use our [workbench](https://github.com/withfatpanda/workbench-wordpress) 
to create a new project from scratch. 

A guide to all that you can do with this framework is coming soon.

In the future, we'll probably write a guide for refactoring existing plugin projects to make use of this framework. Until then,
workbench is the best way to get started right away.

## About This Project

To learn more about the thinking behind this project, you can [read this blog post](https://www.aaroncollegeman.com/do-more-with-wordpress-faster/).

Special gratitude goes out to the [Laravel](https://laravel.com) and [Bedrock](https://roots.io/bedrock) projects, without which I never would have had the foundation to make my dreams-in-code a reality.

And of course, I can't forget to say thank you to the folks behind [WordPress](https://wordpress.org).

You are all beautiful, and I :heart: you.

## About Fat Panda

[Fat Panda](https://www.withfatpanda.com) is a software product consultancy located in Winchester, VA. We specialize in Laravel, WordPress, and Ionic. No matter where you are in the development of your product, we'll meet you there and work with you to propel you forward.

## Contributing

If you run into a problem using this framework, please [open an issue](https://github.com/withfatpanda/workbench-wordpress/issues).

If you want to help make this framework amazing, check out the [help wanted](https://github.com/withfatpanda/workbench-wordpress/issues?q=is%3Aissue+is%3Aopen+label%3A%22help+wanted%22) list.

If you'd like to support this and the other open source projects Fat Panda is building, please join our community of supporters on [Patreon](https://www.patreon.com/withfatpanda).





